## uhub 0.4.1

=== CMakeLists.txt ===
 ##
## Makefile for uhub
## Copyright (C) 2007-2012, Jan Vidar Krey <janvidar@extatic.org>
 #

cmake_minimum_required (VERSION 2.8.3)

project (uhub NONE)
enable_language(C)

set (UHUB_VERSION_MAJOR 0)
set (UHUB_VERSION_MINOR 4)
set (UHUB_VERSION_PATCH 1)

set (PROJECT_SOURCE_DIR "${CMAKE_SOURCE_DIR}/src")

option(RELEASE "Release build, debug build if disabled" ON)
option(LINK_SUPPORT "Allow hub linking" OFF)
option(SSL_SUPPORT "Enable SSL support" ON)
option(USE_OPENSSL "Use OpenSSL's SSL support" ON )
option(SQLITE_SUPPORT "Enable SQLite support" ON)
option(ADC_STRESS "Enable the stress tester client" OFF)

find_package(Git)

if (SSL_SUPPORT)
	if (USE_OPENSSL)
		find_package(OpenSSL)
	else()
		find_package(GnuTLS)
	endif()
	if (NOT GNUTLS_FOUND AND NOT OPENSSL_FOUND)
		message(FATAL_ERROR "Neither OpenSSL nor GnuTLS are not found!")
	endif()
endif()

if (MSVC)
	add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

include_directories("${PROJECT_SOURCE_DIR}")

file (GLOB uhub_SOURCES ${PROJECT_SOURCE_DIR}/core/*.c)
list (REMOVE_ITEM uhub_SOURCES
	${PROJECT_SOURCE_DIR}/core/gen_config.c
	${PROJECT_SOURCE_DIR}/core/main.c
)

file (GLOB adc_SOURCES ${PROJECT_SOURCE_DIR}/adc/*.c)
file (GLOB network_SOURCES ${PROJECT_SOURCE_DIR}/network/*.c)
file (GLOB utils_SOURCES ${PROJECT_SOURCE_DIR}/util/*.c)

set (adcclient_SOURCES
	${PROJECT_SOURCE_DIR}/tools/adcclient.c
	${PROJECT_SOURCE_DIR}/core/ioqueue.c
)

add_library(adc       STATIC ${adc_SOURCES})
add_library(network   STATIC ${network_SOURCES})
add_library(utils     STATIC ${utils_SOURCES})
if(CMAKE_COMPILER_IS_GNUCC)
	set_target_properties(utils PROPERTIES COMPILE_FLAGS -fPIC)
	set_target_properties(network PROPERTIES COMPILE_FLAGS -fPIC)
endif()

add_dependencies(adc utils)
add_dependencies(network utils)

add_executable(uhub ${PROJECT_SOURCE_DIR}/core/main.c ${uhub_SOURCES} )
add_executable(test ${CMAKE_SOURCE_DIR}/autotest/test.c ${uhub_SOURCES} )

add_library(mod_example MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_example.c)
add_library(mod_welcome MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_welcome.c)
add_library(mod_logging MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_logging.c ${PROJECT_SOURCE_DIR}/adc/sid.c)
add_library(mod_auth_simple MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_auth_simple.c )
add_library(mod_chat_history MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_chat_history.c )
add_library(mod_chat_only MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_chat_only.c)
add_library(mod_topic MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_topic.c)
add_library(mod_no_guest_downloads MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_no_guest_downloads.c)

if (SQLITE_SUPPORT)
	add_library(mod_auth_sqlite MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_auth_sqlite.c)
	add_executable(uhub-passwd ${PROJECT_SOURCE_DIR}/tools/uhub-passwd.c)

	target_link_libraries(mod_auth_sqlite sqlite3 utils)
	target_link_libraries(uhub-passwd sqlite3 utils)
	set_target_properties(mod_auth_sqlite PROPERTIES PREFIX "")
endif()


if(WIN32)
	target_link_libraries(uhub ws2_32)
	target_link_libraries(test ws2_32)
	target_link_libraries(mod_logging ws2_32)
	target_link_libraries(mod_welcome ws2_32)
endif()

set_target_properties(
	mod_example
	mod_welcome
	mod_logging
	mod_auth_simple
	mod_chat_history
	mod_chat_only
	mod_no_guest_downloads
	mod_topic
	PROPERTIES PREFIX "")

target_link_libraries(uhub ${CMAKE_DL_LIBS} adc network utils)
target_link_libraries(test ${CMAKE_DL_LIBS} adc network utils)
target_link_libraries(mod_example utils)
target_link_libraries(mod_welcome utils)
target_link_libraries(mod_auth_simple utils)
target_link_libraries(mod_chat_history utils)
target_link_libraries(mod_no_guest_downloads utils)
target_link_libraries(mod_chat_only utils)
target_link_libraries(mod_logging utils)
target_link_libraries(mod_topic utils)
target_link_libraries(utils network)
target_link_libraries(mod_welcome network)
target_link_libraries(mod_logging network)

if(UNIX)
	add_library(adcclient STATIC ${adcclient_SOURCES})
	add_executable(uhub-admin ${PROJECT_SOURCE_DIR}/tools/admin.c)
	target_link_libraries(uhub-admin adcclient adc network utils pthread)
	target_link_libraries(uhub pthread)
	target_link_libraries(test pthread)

	if (ADC_STRESS)
		add_executable(adcrush ${PROJECT_SOURCE_DIR}/tools/adcrush.c ${adcclient_SOURCES})
		target_link_libraries(adcrush adcclient adc network utils pthread)
	endif()
endif()

if (NOT UHUB_REVISION AND GIT_FOUND)
	execute_process(COMMAND ${GIT_EXECUTABLE} show -s --pretty=format:%h
					WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
					OUTPUT_VARIABLE UHUB_REVISION_TEMP
					OUTPUT_STRIP_TRAILING_WHITESPACE)
	if (UHUB_REVISION_TEMP)
		set (UHUB_REVISION "git-${UHUB_REVISION_TEMP}")
	endif()
endif()

if (NOT UHUB_REVISION)
	set (UHUB_REVISION "release")
endif()

set (UHUB_GIT_VERSION "${UHUB_VERSION_MAJOR}.${UHUB_VERSION_MINOR}.${UHUB_VERSION_PATCH}-${UHUB_REVISION}")
message (STATUS "Configuring uhub version: ${UHUB_GIT_VERSION}")

if(OPENSSL_FOUND)
	set(SSL_LIBS ${OPENSSL_LIBRARIES})
	add_definitions(-DSSL_SUPPORT=1 -DSSL_USE_OPENSSL=1)
	include_directories(${OPENSSL_INCLUDE_DIR})
endif()

if (GNUTLS_FOUND)
	set(SSL_LIBS ${GNUTLS_LIBRARIES})
	add_definitions(-DSSL_SUPPORT=1 -DSSL_USE_GNUTLS=1 ${GNUTLS_DEFINITIONS})
	include_directories(${GNUTLS_INCLUDE_DIR})
endif()

if(SSL_SUPPORT)
	target_link_libraries(uhub ${SSL_LIBS})
	target_link_libraries(test ${SSL_LIBS})
	if(UNIX)
		target_link_libraries(uhub-admin ${SSL_LIBS})
	endif()
	target_link_libraries(mod_welcome ${SSL_LIBS})
	target_link_libraries(mod_logging ${SSL_LIBS})
	if (ADC_STRESS)
		target_link_libraries(adcrush ${SSL_LIBS})
	endif()
endif()

configure_file ("${PROJECT_SOURCE_DIR}/version.h.in" "${PROJECT_SOURCE_DIR}/version.h")

mark_as_advanced(FORCE CMAKE_BUILD_TYPE)
if (RELEASE)
	set(CMAKE_BUILD_TYPE Release)
else()
	set(CMAKE_BUILD_TYPE Debug)
	# add_definitions(-DDEBUG)
endif()

if (UNIX)
	install( TARGETS uhub RUNTIME DESTINATION bin )
	install( TARGETS mod_example mod_welcome mod_logging mod_auth_simple mod_auth_sqlite mod_chat_history mod_chat_only mod_topic mod_no_guest_downloads DESTINATION /usr/lib/uhub/ OPTIONAL )
	install( FILES ${CMAKE_SOURCE_DIR}/doc/uhub.conf ${CMAKE_SOURCE_DIR}/doc/plugins.conf ${CMAKE_SOURCE_DIR}/doc/rules.txt ${CMAKE_SOURCE_DIR}/doc/motd.txt DESTINATION /etc/uhub OPTIONAL )

	if (SQLITE_SUPPORT)
		install( TARGETS uhub-passwd RUNTIME DESTINATION bin )
	endif()
endif()

## uhub 0.3.2

=== debian/changelog ===
uhub (0.3.2-1) unstable; urgency=low

  * Initial release (closes: #643290).

 -- Boris Pek <tehnick-8@mail.ru>  Sat, 08 Oct 2011 18:03:02 +0300

=== debian/control ===
Source: uhub
Section: net
Priority: optional
Maintainer: Boris Pek <tehnick-8@mail.ru>
Build-Depends: debhelper (>= 7)
Homepage: http://www.uhub.org/
Vcs-Git: git://github.com/tehnick/uhub-debian.git
Vcs-Browser: https://github.com/tehnick/uhub-debian
Standards-Version: 3.9.2

Package: uhub
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: High performance Advanced Direct Connect p2p hub
 uhub is a high performance peer-to-peer hub for the ADC network.
 Its low memory footprint allows it to handle several thousand users on
 high-end servers, or a small private hub on embedded hardware.
 .
 uhub uses the Advanced Direct Connect protocol, and is compatible with
 DC++, LinuxDC++, EiskaltDC++ and other ADC clients.
 .
 Key features:
  - High performance and low memory usage
  - IPv4 and IPv6 support
  - Experimental SSL support (optional)
  - Advanced access control support
  - Easy configuration

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

ifeq (,$(NUMJOBS))
	NUMJOBS = 1
endif

PACKAGE = uhub
DEVELOPER = janvidar
PROJECT = uhub

CUR_VER = $(shell dpkg-parsechangelog | sed -ne 's/^Version: \(\([0-9]\+\):\)\?\(.*\)-.*/\3/p')

MAKEOPTS := DESTDIR=$(CURDIR)/debian/uhub/ \
            UHUB_PREFIX=$(CURDIR)/debian/uhub/usr \
            RELEASE=YES

build: build-arch build-indep

build-arch: build-stamp

build-indep: build-stamp

build-stamp:
	dh_testdir
	$(MAKE) -j$(NUMJOBS) $(MAKEOPTS)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	$(MAKE) clean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) install $(MAKEOPTS)
	chmod 0750 $(CURDIR)/debian/uhub/var/log/uhub

get-orig-source:
	# preparation
	rm -rf  "$(CUR_VER)"/ "$(PACKAGE)-$(CUR_VER)"/
	# sources
	wget -4 "http://nodeload.github.com/$(DEVELOPER)/$(PROJECT)/tarball/$(CUR_VER)"
	rm -rf $(DEVELOPER)-$(PROJECT)-*
	tar xzf "$(CUR_VER)"
	mv $(DEVELOPER)-$(PROJECT)-* "$(PACKAGE)-$(CUR_VER)"
	# tarball
	tar -cjf "$(PACKAGE)_$(CUR_VER).orig.tar.bz2" "$(PACKAGE)-$(CUR_VER)"
	# cleaning
	rm -rf "$(PACKAGE)-$(CUR_VER)" "$(CUR_VER)"

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installinit
	dh_installlogrotate
	dh_installman -A
	dh_installchangelogs ChangeLog
	dh_strip
	dh_lintian
	dh_compress
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch

.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
https://github.com/janvidar/uhub/tags .*/janvidar/uhub/tarball/(\d.+) debian uupdate

## uhub 0.4.1

=== debian/changelog ===
uhub (0.4.1-3) unstable; urgency=low

  * Move package to unstable: no changes required.

 -- Boris Pek <tehnick-8@mail.ru>  Sun, 12 May 2013 20:09:49 +0300

uhub (0.4.1-2) experimental; urgency=low

  * Add file debian/patches/fix-build-on-hurd-i386:
    fix build in Debian GNU/Hurd.

 -- Boris Pek <tehnick-8@mail.ru>  Tue, 20 Nov 2012 22:44:22 +0200

uhub (0.4.1-1) experimental; urgency=low

  * Update to stable release 0.4.1.
  * Delete debian/patches/*: accepted in upstream.
  * Update debian/rules and debian/watch: fix after recent changes in GitHub.

 -- Boris Pek <tehnick-8@mail.ru>  Wed, 07 Nov 2012 23:42:52 +0200

uhub (0.4.0+git20121013-55-g7fae42a-2) experimental; urgency=low

  * Add debian/patches/fix-build-on-kfreebsd:
    fix build in Debian GNU/kFreeBSD.

 -- Boris Pek <tehnick-8@mail.ru>  Sun, 14 Oct 2012 02:20:16 +0300

uhub (0.4.0+git20121013-55-g7fae42a-1) experimental; urgency=low

  * Update to Git snapshot.
  * Update debian/control:
    add build dependency from cmake.
  * Update debian/rules:
    upstream uses CMake now instead of manually written Makefile.
  * Update debian/uhub.lintian-overrides:
    false positives for lintian tag hardening-no-fortify-functions.
  * Bump debhelper version to 8 (was 7.0.50~); update debian/compat.

 -- Boris Pek <tehnick-8@mail.ru>  Sat, 13 Oct 2012 23:14:27 +0300

uhub (0.4.0-1) experimental; urgency=low

  * Update to stable release 0.4.0.
  * Delete debian/doc/uhub-passwd.1: now available in upstream.
  * Update debian/uhub.manpages: see above.
  * Update debian/rules:
    - simplify rules
    - enable verbose output during build
    - fix get-orig-source section in according with Debian Policy §4.9

 -- Boris Pek <tehnick-8@mail.ru>  Wed, 30 May 2012 23:42:48 +0300

uhub (0.4.0~git20120423-9efe4bc-1) experimental; urgency=low

  * Update to GIT snapshot.
  * Bumped Standards-Version to 3.9.3.
  * Changed tarball compression format: LZMA2 is used now.
  * debian/rules was updated:
    - now dh is used instead of direct dh_* commands
    - now uscan is used for checking current upstream version
      (dpkg-parsechangelog was used earlier)
    - USE_SSL configuration option is enabled
    - used hardening flags in compiler options
  * debian/doc/uhub.1, debian/doc/uhub.conf and debian/doc/users.conf
    were removed: now they are available in upstream.
  * debian/doc/uhub-passwd.1 was created: there is no such man page in
    upstream yet.
  * debian/uhub.manpages was updated (see above).
  * debian/control was updated: added dependence from packages
    fakeroot, libsqlite3-dev and libssl-dev
  * debian/copyright was updated:
    - URL in Format field was updated
    - years were updated
    - OpenSSL exception was officially received
      (see file COPYING.OpenSSL in sources)
  * Upstream possibly fixed build for hurd-i386,
    kfreebsd-i386, kfreebsd-amd64, s390 and s390x.

 -- Boris Pek <tehnick-8@mail.ru>  Mon, 23 Apr 2012 23:53:57 +0300

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,12 @@
 Section: net
 Priority: optional
 Maintainer: Boris Pek <tehnick-8@mail.ru>
-Build-Depends: debhelper (>= 7)
+Build-Depends: debhelper (>= 8), cmake (>= 2.8.3), fakeroot,
+ libsqlite3-dev, libssl-dev
 Homepage: http://www.uhub.org/
 Vcs-Git: git://github.com/tehnick/uhub-debian.git
 Vcs-Browser: https://github.com/tehnick/uhub-debian
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 
 Package: uhub
 Architecture: any
@@ -22,6 +23,6 @@
  Key features:
   - High performance and low memory usage
   - IPv4 and IPv6 support
-  - Experimental SSL support (optional)
+  - Experimental SSL support
   - Advanced access control support
   - Easy configuration

=== debian/watch ===
version=3
https://github.com/janvidar/uhub/tags .*/janvidar/uhub/archive/(\d.+)\.tar\.gz debian uupdate

## uhub 0.5.1

=== CMakeLists.txt ===
 ##
## Makefile for uhub
## Copyright (C) 2007-2013, Jan Vidar Krey <janvidar@extatic.org>
 #

cmake_minimum_required (VERSION 2.8.2)

project (uhub NONE)
enable_language(C)

set (UHUB_VERSION_MAJOR 0)
set (UHUB_VERSION_MINOR 5)
set (UHUB_VERSION_PATCH 1)

set (PROJECT_SOURCE_DIR "${CMAKE_SOURCE_DIR}/src")
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake/Modules)

option(RELEASE "Release build, debug build if disabled" ON)
option(LOWLEVEL_DEBUG, "Enable low level debug messages." OFF)
option(SSL_SUPPORT "Enable SSL support" ON)
option(USE_OPENSSL "Use OpenSSL's SSL support" ON )
option(SYSTEMD_SUPPORT "Enable systemd notify and journal logging" OFF)
option(ADC_STRESS "Enable the stress tester client" OFF)

find_package(Git)
find_package(Sqlite3)

include(TestBigEndian)
include(CheckSymbolExists) 
include(CheckIncludeFile)
include(CheckTypeSize)

#Some functions need this to be found
add_definitions(-D_GNU_SOURCE)
set(CMAKE_REQUIRED_DEFINITIONS "${CMAKE_REQUIRED_DEFINITIONS} -D_GNU_SOURCE")

TEST_BIG_ENDIAN(BIGENDIAN)
if (BIGENDIAN)
	add_definitions(-DARCH_BIGENDIAN)
endif()

if (NOT RELEASE)
        add_definitions(-DDEBUG)
endif()

if (SSL_SUPPORT)
	if (USE_OPENSSL)
		find_package(OpenSSL)
	else()
		find_package(GnuTLS)
	endif()
	if (NOT GNUTLS_FOUND AND NOT OPENSSL_FOUND)
		message(FATAL_ERROR "Neither OpenSSL nor GnuTLS were found!")
	endif()
endif()

if (NOT SQLITE3_FOUND)
    message(FATAL_ERROR "SQLite3 is not found!")
endif()

if (SYSTEMD_SUPPORT)
        INCLUDE(FindPkgConfig)
        pkg_search_module(SD REQUIRED libsystemd)
endif()

if (MSVC)
	add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

check_include_file(stdint.h HAVE_STDINT_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)
if (HAVE_SYS_TYPES_H)
set (CMAKE_EXTRA_INCLUDE_FILES ${CMAKE_EXTRA_INCLUDE_FILES} "sys/types.h")
endif()
check_type_size( ssize_t SSIZE_T )
check_symbol_exists(memmem string.h HAVE_MEMMEM)
check_symbol_exists(strndup string.h HAVE_STRNDUP)

include_directories("${PROJECT_SOURCE_DIR}")
include_directories(${SQLITE3_INCLUDE_DIRS})
link_directories(${SQLITE3_LIBRARY_DIRS})

file (GLOB uhub_SOURCES ${PROJECT_SOURCE_DIR}/core/*.c)
list (REMOVE_ITEM uhub_SOURCES
	${PROJECT_SOURCE_DIR}/core/gen_config.c
	${PROJECT_SOURCE_DIR}/core/main.c
)

file (GLOB adc_SOURCES ${PROJECT_SOURCE_DIR}/adc/*.c)
file (GLOB network_SOURCES ${PROJECT_SOURCE_DIR}/network/*.c)
file (GLOB utils_SOURCES ${PROJECT_SOURCE_DIR}/util/*.c)

set (adcclient_SOURCES
	${PROJECT_SOURCE_DIR}/tools/adcclient.c
	${PROJECT_SOURCE_DIR}/core/ioqueue.c
)

add_library(adc       STATIC ${adc_SOURCES})
add_library(network   STATIC ${network_SOURCES})
add_library(utils     STATIC ${utils_SOURCES})
if ("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU" OR "${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
	set_target_properties(utils PROPERTIES COMPILE_FLAGS -fPIC)
	set_target_properties(network PROPERTIES COMPILE_FLAGS -fPIC)
endif()

add_dependencies(adc utils)
add_dependencies(network utils)

add_executable(uhub ${PROJECT_SOURCE_DIR}/core/main.c ${uhub_SOURCES} )
add_executable(autotest-bin ${CMAKE_SOURCE_DIR}/autotest/test.c ${uhub_SOURCES} )
add_executable(uhub-passwd ${PROJECT_SOURCE_DIR}/tools/uhub-passwd.c)

add_library(mod_example MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_example.c)
add_library(mod_welcome MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_welcome.c)
add_library(mod_logging MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_logging.c ${PROJECT_SOURCE_DIR}/adc/sid.c)
add_library(mod_auth_simple MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_auth_simple.c )
add_library(mod_chat_history MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_chat_history.c )
add_library(mod_chat_history_sqlite MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_chat_history_sqlite.c )
add_library(mod_chat_only MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_chat_only.c)
add_library(mod_topic MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_topic.c)
add_library(mod_no_guest_downloads MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_no_guest_downloads.c)
add_library(mod_auth_sqlite MODULE ${PROJECT_SOURCE_DIR}/plugins/mod_auth_sqlite.c)

if(WIN32)
	target_link_libraries(uhub ws2_32)
	target_link_libraries(autotest-bin ws2_32)
	target_link_libraries(mod_logging ws2_32)
	target_link_libraries(mod_welcome ws2_32)
endif()

set_target_properties(
	mod_example
	mod_welcome
	mod_logging
	mod_auth_simple
	mod_auth_sqlite
	mod_chat_history
	mod_chat_history_sqlite
	mod_chat_only
	mod_no_guest_downloads
	mod_topic
	PROPERTIES PREFIX "")

target_link_libraries(uhub ${CMAKE_DL_LIBS} adc network utils)
target_link_libraries(uhub-passwd ${SQLITE3_LIBRARIES} utils)
target_link_libraries(autotest-bin ${CMAKE_DL_LIBS} adc network utils)
target_link_libraries(mod_example utils)
target_link_libraries(mod_welcome utils)
target_link_libraries(mod_auth_simple utils)
target_link_libraries(mod_auth_sqlite ${SQLITE3_LIBRARIES} utils)
target_link_libraries(mod_chat_history utils)
target_link_libraries(mod_chat_history_sqlite ${SQLITE3_LIBRARIES} utils)
target_link_libraries(mod_no_guest_downloads utils)
target_link_libraries(mod_chat_only utils)
target_link_libraries(mod_logging utils)
target_link_libraries(mod_topic utils)
target_link_libraries(utils network)
target_link_libraries(mod_welcome network)
target_link_libraries(mod_logging network)


if(UNIX)
	add_library(adcclient STATIC ${adcclient_SOURCES})
	add_executable(uhub-admin ${PROJECT_SOURCE_DIR}/tools/admin.c)
	target_link_libraries(uhub-admin adcclient adc network utils pthread)
	target_link_libraries(uhub pthread)
	target_link_libraries(autotest-bin pthread)

	if (ADC_STRESS)
		add_executable(adcrush ${PROJECT_SOURCE_DIR}/tools/adcrush.c ${adcclient_SOURCES})
		target_link_libraries(adcrush adcclient adc network utils pthread)
	endif()
endif()

if (NOT UHUB_REVISION AND GIT_FOUND)
	execute_process(COMMAND ${GIT_EXECUTABLE} show -s --pretty=format:%h
					WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
					OUTPUT_VARIABLE UHUB_REVISION_TEMP
					OUTPUT_STRIP_TRAILING_WHITESPACE)
	if (UHUB_REVISION_TEMP)
		set (UHUB_REVISION "git-${UHUB_REVISION_TEMP}")
	endif()
endif()

if (NOT UHUB_REVISION)
	set (UHUB_REVISION "release")
endif()

set (UHUB_GIT_VERSION "${UHUB_VERSION_MAJOR}.${UHUB_VERSION_MINOR}.${UHUB_VERSION_PATCH}-${UHUB_REVISION}")
message (STATUS "Configuring uhub version: ${UHUB_GIT_VERSION}")

if(OPENSSL_FOUND)
	set(SSL_LIBS ${OPENSSL_LIBRARIES})
	add_definitions(-DSSL_SUPPORT=1 -DSSL_USE_OPENSSL=1)
	include_directories(${OPENSSL_INCLUDE_DIR})
endif()

if (GNUTLS_FOUND)
	set(SSL_LIBS ${GNUTLS_LIBRARIES})
	add_definitions(-DSSL_SUPPORT=1 -DSSL_USE_GNUTLS=1 ${GNUTLS_DEFINITIONS})
	include_directories(${GNUTLS_INCLUDE_DIR})
endif()

if(SSL_SUPPORT)
	target_link_libraries(uhub ${SSL_LIBS})
	target_link_libraries(autotest-bin ${SSL_LIBS})
	if(UNIX)
		target_link_libraries(uhub-admin ${SSL_LIBS})
	endif()
	target_link_libraries(mod_welcome ${SSL_LIBS})
	target_link_libraries(mod_logging ${SSL_LIBS})
	if (ADC_STRESS)
		target_link_libraries(adcrush ${SSL_LIBS})
	endif()
endif()

if (SYSTEMD_SUPPORT)
        target_link_libraries(uhub ${SD_LIBRARIES})
        target_link_libraries(autotest-bin ${SD_LIBRARIES})
        target_link_libraries(uhub-passwd ${SD_LIBRARIES})
        target_link_libraries(uhub-admin ${SD_LIBRARIES})
        include_directories(${SD_INCLUDE_DIRS})
        add_definitions(-DSYSTEMD)
endif()

configure_file ("${PROJECT_SOURCE_DIR}/version.h.in" "${PROJECT_SOURCE_DIR}/version.h")
configure_file ("${PROJECT_SOURCE_DIR}/system.h.in" "${PROJECT_SOURCE_DIR}/system.h")

# mark_as_advanced(FORCE CMAKE_BUILD_TYPE)
# if (RELEASE)
#	set(CMAKE_BUILD_TYPE Release)
#	add_definitions(-DNDEBUG)
#else()
#	set(CMAKE_BUILD_TYPE Debug)
#	add_definitions(-DDEBUG)
#endif()

if (LOWLEVEL_DEBUG)
	add_definitions(-DLOWLEVEL_DEBUG)
endif()

if (UNIX)
	install( TARGETS uhub uhub-passwd RUNTIME DESTINATION bin )
	install( TARGETS mod_example mod_welcome mod_logging mod_auth_simple mod_auth_sqlite mod_chat_history mod_chat_history_sqlite mod_chat_only mod_topic mod_no_guest_downloads DESTINATION /usr/lib/uhub/ OPTIONAL )
	install( FILES ${CMAKE_SOURCE_DIR}/doc/uhub.conf ${CMAKE_SOURCE_DIR}/doc/plugins.conf ${CMAKE_SOURCE_DIR}/doc/rules.txt ${CMAKE_SOURCE_DIR}/doc/motd.txt DESTINATION /etc/uhub OPTIONAL )
endif()

=== debian/changelog ===
uhub (0.5.1-1) unstable; urgency=medium

  * New upstream version
    Closes: #871436
  * New upstream location
    Closes: #971652
  * d/watch
     - Point to new upstream
     - Version = 5
  * Maintain package in Salvage team
    Closes: #1116710
  * d/rules: Cleanup from unneeded and redundant things
  * Standards-Version: 4.7.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Secure URI in copyright format (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Update lintian override info format in d/uhub.lintian-overrides
  * Add service file
    Closes: #1039402
  * Fix build using CMake 4
    Closes: #1113598
  * Remove outdated information from d/copyright
  * Drop fakeroot from Build-Depends
  * Drop unneeded tags from lintian-overrides
  * d/rules: hardening flags

 -- Andreas Tille <tille@debian.org>  Mon, 20 Oct 2025 11:16:57 +0200

uhub (0.4.1-3.3) unstable; urgency=medium

  * Non-maintainer upload.
  [ zhangdandan <zhangdandan@loongson.cn> ]
  * Add support for LoongArch (Closes: #1074428)

  [ Zixing Liu <zixing.liu@canonical.com> ]
  * Fix FTBFS with newer gcc (Closes: #1066247)
  * Fix FTBFS with riscv64 (Closes: #1020965)
    - patch contributed by Eric Long <i@hack3r.moe>

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 05 Nov 2024 07:38:55 +0100

uhub (0.4.1-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Add arm64-fix-ftbfs.patch to fix FTBFS on arm64. (Closes: #770175)

 -- Emanuele Rocca <ema@debian.org>  Mon, 12 Sep 2022 11:14:29 +0200

uhub (0.4.1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Bumped DH level to 10.
  * Bumped Standards-Version to 3.9.8.
  * patches/openssl1.1.patch: added to provide compatibility with OpenSSL 1.1.
    Thanks to Reiner Herrmann <reiner@reiner-h.de>. (Closes: #828583)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 23 Dec 2016 02:27:45 -0200

=== debian/control ===
Source: uhub
Standards-Version: 4.7.2
Maintainer: Package Salvaging Team <team+salvage@tracker.debian.org>
Uploaders:
 Boris Pek <tehnick-8@mail.ru>,
 Andreas Tille <tille@debian.org>
Section: net
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libsqlite3-dev,
 libssl-dev,
Vcs-Browser: https://salsa.debian.org/salvage-team/uhub
Vcs-Git: https://salsa.debian.org/salvage-team/uhub.git
Homepage: https://github.com/modelrockettier/uhub

Package: uhub
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: High performance Advanced Direct Connect p2p hub
 uhub is a high performance peer-to-peer hub for the ADC network.
 Its low memory footprint allows it to handle several thousand users on
 high-end servers, or a small private hub on embedded hardware.
 .
 uhub uses the Advanced Direct Connect protocol, and is compatible with
 DC++, LinuxDC++, EiskaltDC++ and other ADC clients.
 .
 Key features:
  - High performance and low memory usage
  - IPv4 and IPv6 support
  - Experimental SSL support
  - Advanced access control support
  - Easy configuration

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -f $(CURDIR)/src/version.h

override_dh_auto_install:
	dh_auto_install
	chmod 0750 $(CURDIR)/debian/`dh_listpackages`/var/log/uhub

=== debian/watch ===
Version: 5

Template: Github
Owner: modelrockettier
Project: @PACKAGE@
